Package net.sf.saxon.expr

## Interface Callable

- All Known Subinterfaces:
    `ArrayItem`, `Function`, `MapItem`
  All Known Implementing Classes:
    `Abs`, `AbstractArrayItem`, `AbstractFunction`, `AccessorFn`, `AccessorFn.DayFromDate`, `AccessorFn.DayFromDateTime`, `AccessorFn.DaysFromDuration`, `AccessorFn.HoursFromDateTime`, `AccessorFn.HoursFromDuration`, `AccessorFn.HoursFromTime`, `AccessorFn.LocalNameFromQName`, `AccessorFn.MinutesFromDateTime`, `AccessorFn.MinutesFromDuration`, `AccessorFn.MinutesFromTime`, `AccessorFn.MonthFromDate`, `AccessorFn.MonthFromDateTime`, `AccessorFn.MonthsFromDuration`, `AccessorFn.NamespaceUriFromQName`, `AccessorFn.PrefixFromQName`, `AccessorFn.SecondsFromDateTime`, `AccessorFn.SecondsFromDuration`, `AccessorFn.SecondsFromTime`, `AccessorFn.TimezoneFromDate`, `AccessorFn.TimezoneFromDateTime`, `AccessorFn.TimezoneFromTime`, `AccessorFn.YearFromDate`, `AccessorFn.YearFromDateTime`, `AccessorFn.YearsFromDuration`, `AccumulatorFn`, `AccumulatorFn.AccumulatorAfter`, `AccumulatorFn.AccumulatorBefore`, `Adjust_1`, `Adjust_2`, `Aggregate`, `AnalyzeStringFn`, `AnalyzeUri`, `ApplyFn`, `ArithmeticExpression10`, `ArrayFunctionSet.ArrayAppend`, `ArrayFunctionSet.ArrayFilter`, `ArrayFunctionSet.ArrayFlatten`, `ArrayFunctionSet.ArrayFoldLeft`, `ArrayFunctionSet.ArrayFoldRight`, `ArrayFunctionSet.ArrayForEach`, `ArrayFunctionSet.ArrayForEachPair`, `ArrayFunctionSet.ArrayFromSequence`, `ArrayFunctionSet.ArrayGet`, `ArrayFunctionSet.ArrayHead`, `ArrayFunctionSet.ArrayInsertBefore`, `ArrayFunctionSet.ArrayJoin`, `ArrayFunctionSet.ArrayPut`, `ArrayFunctionSet.ArrayRemove`, `ArrayFunctionSet.ArrayReverse`, `ArrayFunctionSet.ArraySize`, `ArrayFunctionSet.ArraySubarray`, `ArrayFunctionSet.ArrayTail`, `ArrayFunctionSet.ArrayToSequence`, `ArrayMember`, `ArraySort`, `AtomicConstructorFunction`, `AvailableEnvironmentVariables`, `AvailableSystemProperties`, `Average`, `BaseUri_1`, `BooleanFn`, `CallableFunction`, `CallableWithBoundFocus`, `CastExpression`, `Ceiling`, `CharactersFn`, `CodepointEqual`, `CodepointsToString`, `CoercedFunction`, `CollatingFunctionFixed`, `CollatingFunctionFree`, `CollationKeyFn`, `CollectionFn`, `Compare`, `CompileQuery`, `CompileStylesheet`, `CompileXPath`, `Concat`, `ConstantFunction`, `ConstantFunction.False`, `ConstantFunction.True`, `Contains`, `ContainsToken`, `ContextAccessorFunction`, `ContextItemAccessorFunction`, `ContextItemAccessorFunction.Number_0`, `ContextItemAccessorFunction.StringAccessor`, `CopyOfFn`, `Count`, `Current`, `CurrentGroup`, `CurrentGroupCall`, `CurrentGroupingKey`, `CurrentGroupingKeyCall`, `CurrentMergeGroup`, `CurrentMergeKey`, `CurrentOutputUri`, `CurriedFunction`, `Data_1`, `DateTimeConstructor`, `DecimalDivide`, `DeepEqual`, `DeepEqual`, `DelegatingArrayItem`, `DelegatingMapItem`, `DictionaryMap`, `DistinctValues`, `Doc`, `Doc_2`, `DocAvailable`, `DocumentFn`, `DocumentUri_1`, `DynamicContextAccessor`, `DynamicContextAccessor.CurrentDate`, `DynamicContextAccessor.CurrentDateTime`, `DynamicContextAccessor.CurrentTime`, `DynamicContextAccessor.DefaultLanguage`, `DynamicContextAccessor.ImplicitTimezone`, `ElementAvailable`, `Empty`, `EncodeForUri`, `Ending`, `Ending.ItemsBefore`, `Ending.ItemsUntil`, `EndsWith`, `EnvironmentVariable`, `EQName`, `Error`, `EscapeHtmlUri`, `Eval`, `Evaluate`, `Exists`, `EXPathFileFunctionSet.BaseDir`, `ExpressionFn`, `ExsltCommonFunctionSet.NodeSetFn`, `ExsltCommonFunctionSet.ObjectTypeFn`, `ExtensionFunctionCall`, `FilterFn`, `Floor`, `FoldingFunction`, `FoldLeftFn`, `FoldRightFn`, `ForEachFn`, `ForEachPairFn`, `FormatDate`, `FormatInteger`, `FormatNumber`, `FunctionAnnotations`, `FunctionArity`, `FunctionAvailable`, `FunctionLookup`, `FunctionName`, `GeneralComparison`, `GeneralComparison10`, `GeneralComparison20`, `GeneralComparisonEE`, `GenerateId_1`, `GroupStarting`, `HasChildren_1`, `HashTrieMap`, `HeadFn`, `HighestOrLowest`, `Idref`, `ImmutableArrayItem`, `Index`, `IndexOf`, `IndexWhere`, `Innermost`, `InScopeNamespacesFn`, `InScopePrefixes`, `InsertBefore`, `IntegratedFunctionCall`, `IriToUri`, `IsNaN`, `IXSLFunctionSet.Call`, `IXSLFunctionSet.Eval`, `IXSLFunctionSet.ScheduleActionFn`, `IXSLFunctionSet.Source`, `IXSLFunctionSet.Stub`, `JavaExtensionFunctionCall`, `JavaExtensionLibrary.UnresolvedExtensionFunctionCall`, `JAXPVariableReference`, `JsonDoc`, `JsonToXMLFn`, `KeyFn`, `KeyMap`, `Lang`, `LastModified`, `Leading`, `ListCastableFunction`, `ListConstructorFunction`, `LoadXqueryModule`, `LocalName_1`, `LowerCase`, `MapCreate`, `MapFunctionSet.MapContains`, `MapFunctionSet.MapEntry`, `MapFunctionSet.MapFind`, `MapFunctionSet.MapForEach`, `MapFunctionSet.MapGet`, `MapFunctionSet.MapKeys`, `MapFunctionSet.MapMerge`, `MapFunctionSet.MapPut`, `MapFunctionSet.MapRemove`, `MapFunctionSet.MapSize`, `MapSearch`, `MapUntypedContains`, `Matches`, `MathFunctionSet.AcosFn`, `MathFunctionSet.AsinFn`, `MathFunctionSet.Atan2Fn`, `MathFunctionSet.AtanFn`, `MathFunctionSet.CosFn`, `MathFunctionSet.Exp10Fn`, `MathFunctionSet.ExpFn`, `MathFunctionSet.Log10Fn`, `MathFunctionSet.LogFn`, `MathFunctionSet.PiFn`, `MathFunctionSet.PowFn`, `MathFunctionSet.SinFn`, `MathFunctionSet.SqrtFn`, `MathFunctionSet.TanFn`, `MemoFunction`, `MessageCount`, `Minimax`, `Minimax.Max`, `Minimax.Min`, `Name_1`, `NamespaceForPrefix`, `NamespaceUri_1`, `NewAttribute`, `NewComment`, `NewDocument`, `NewElement`, `NewNamespace`, `NewProcessingInstruction`, `NewText`, `Nilled_1`, `NodeName_1`, `NormalizeSpace_1`, `NormalizeUnicode`, `NotFn`, `Number_1`, `ObjectMap`, `OriginalFunction`, `Outermost`, `Parse`, `ParseHtml`, `ParseIetfDate`, `ParseJsonFn`, `ParseXml`, `ParseXmlFragment`, `ParseXPath`, `Path_1`, `PedigreeArrayItem`, `PedigreeFn`, `PedigreeMapItem`, `PositionAndLast`, `PositionAndLast.Last`, `PositionAndLast.Position`, `Put`, `QNameFn`, `QueryFn`, `RandomNumberGenerator`, `RangeKey`, `RegexFunction`, `RegexFunctionSansFlags`, `RegexGroup`, `Remove`, `Replace`, `ReplaceWith`, `ResolveQName`, `ResolveURI`, `Reverse`, `Root_1`, `Round`, `RoundHalfToEven`, `ScalarSystemFunction`, `SchemaFn`, `SendMail`, `Serialize`, `Serialize`, `SimpleArrayItem`, `SimpleExpression`, `SingleEntryMap`, `SnapshotFn`, `Sort_1`, `Sort_2`, `Sort_3`, `SQLConnect.ConnectInstruction`, `SQLConnectFn`, `SQLDeleteFn`, `SQLExecuteFn`, `SQLInsertFn`, `SQLPreparedQueryFn`, `SQLPreparedStatementFn`, `SQLQueryFn`, `SQLTableFn`, `SQLUpdateFn`, `Starting`, `Starting.ItemsAfter`, `Starting.ItemsFrom`, `StartsWith`, `StaticBaseUri`, `StaticContextAccessor`, `StaticContextAccessor.DefaultCollation`, `StaticFunctionCall`, `StreamableUserFunction`, `StreamAvailable`, `StreamFn`, `String_1`, `StringJoin`, `StringLength_1`, `StringToCodepoints`, `Subsequence_2`, `Subsequence_3`, `Substring`, `SubstringAfter`, `SubstringBefore`, `Sum`, `SuperId`, `SuperId.ElementWithId`, `SuperId.Id`, `SystemFunction`, `SystemFunctionCall`, `SystemFunctionCall.Optimized`, `SystemFunctionWithBoundContextItem`, `SystemProperty`, `TailFn`, `TimestampFn`, `Tokenize_1`, `Tokenize_3`, `Trace`, `TransformFn`, `TransformFn`, `Translate`, `TreatFn`, `TreatFn.ExactlyOne`, `TreatFn.OneOrMore`, `TreatFn.ZeroOrOne`, `TypeAvailable`, `UnionCastableFunction`, `UnionConstructorFunction`, `Unordered`, `UnparsedEntity`, `UnparsedEntity.UnparsedEntityPublicId`, `UnparsedEntity.UnparsedEntityUri`, `UnparsedText`, `UnparsedTextAvailable`, `UnparsedTextFunction`, `UnparsedTextLines`, `UnresolvedXQueryFunctionItem`, `UpperCase`, `UriCollection`, `UserFunction`, `UserFunctionReference`, `UserFunctionReference.BoundUserFunction`, `ValidateFn`, `VendorFunctionSetHE.DynamicErrorInfoFn`, `VendorFunctionSetHE.HasLocalNamespaces`, `VendorFunctionSetHE.HasUniformNamespaces`, `VendorFunctionSetHE.IsWholeNumberFn`, `WithPedigree`, `XMLToJsonFn`, `XPathFunctionCall`, `XQueryFunctionLibrary.UnresolvedCallable`

      public interface Callable

  A generic interface for calling expressions by supplying the values of their subexpressions

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Sequence` | `call​(XPathContext context, Sequence[] arguments)` | Call the Callable.

- - ### Method Detail

    - #### call

          Sequence call​(XPathContext context,
                        Sequence[] arguments)
                 throws XPathException

      Call the Callable.
      Parameters:
        `context` - the dynamic evaluation context
        `arguments` - the values of the arguments, supplied as Sequences.

        Generally it is advisable, if calling iterate() to process a supplied sequence, to call it only once; if the value is required more than once, it should first be converted to a `GroundedValue` by calling the utility method SequenceTool.toGroundedValue().

        If the expected value is a single item, the item should be obtained by calling Sequence.head(): it cannot be assumed that the item will be passed as an instance of `Item` or `AtomicValue`.

        It is the caller's responsibility to perform any type conversions required to convert arguments to the type expected by the callee. An exception is where this Callable is explicitly an argument-converting wrapper around the original Callable.

      Returns:
        the result of the evaluation, in the form of a Sequence. It is the responsibility of the callee to ensure that the type of result conforms to the expected result type.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the expression